#
# This has been ported by Hiroshi Saito(hiroshi@winpg.jp)
# Copyright notice of the original as below.
#
#
# * << Haru Free PDF Library 2.0.0 >> -- link_annotation.c
# *
# * Copyright(c) 1999-2006 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
# *
# * Permission to use, copy, modify, distribute and sell this software
# * and its documentation for any purpose is hereby granted without fee,
# * provided that the above copyright notice appear in all copies and
# * that both that copyright notice and this permission notice appear
# * in supporting documentation.
# * It is provided "as is" without express or implied warranty.
# *
#

@load "pdf"

# ----
# main
# ----

BEGIN {
    # rect structure number is 1:left 2:bottom 3:right 4:top
    rect1[1] =  50;rect1[2] = 350;rect1[3] = 150;rect1[4] = 400;
    rect2[1] = 210;rect2[2] = 350;rect2[3] = 350;rect2[4] = 400;
    rect3[1] =  50;rect3[2] = 250;rect3[3] = 150;rect3[4] = 300;
    rect4[1] = 210;rect4[2] = 250;rect4[3] = 350;rect4[4] = 300;
    rect5[1] =  50;rect5[2] = 150;rect5[3] = 150;rect5[4] = 200;
    rect6[1] = 210;rect6[2] = 150;rect6[3] = 350;rect6[4] = 200;
    rect7[1] =  50;rect7[2] =  50;rect7[3] = 150;rect7[4] = 100;
    rect8[1] = 210;rect8[2] =  50;rect8[3] = 350;rect8[4] = 100;
    rect9[1] =  10;rect9[2] = 490;rect9[3] = 120;rect9[4] = 475;

    fname = "pdf_annotation.pdf";

    pdf = HPDF_New(NULL, NULL);

    # use Times-Roman font. 
    font = HPDF_GetFont(pdf, "Times-Roman", "WinAnsiEncoding");

    page = HPDF_AddPage(pdf);

    HPDF_Page_SetWidth(page, 400);
    HPDF_Page_SetHeight(page, 500);

    HPDF_Page_BeginText(page);
    HPDF_Page_SetFontAndSize(page, font, 16);
    HPDF_Page_MoveTextPos(page, 130, 450);
    HPDF_Page_ShowText(page, "Annotation Demo");
    HPDF_Page_EndText(page);

    annot = HPDF_Page_CreateTextAnnot(page, rect1, 
                "Annotation with Comment Icon.\n" \
                " This annotation set to be opened initially.",
                NULL);

    HPDF_TextAnnot_SetIcon(annot, HPDF_ANNOT_ICON_COMMENT);
    HPDF_TextAnnot_SetOpened(annot, HPDF_TRUE);

    annot = HPDF_Page_CreateTextAnnot(page, rect2,
                "Annotation with Key Icon", NULL);
    HPDF_TextAnnot_SetIcon(annot, HPDF_ANNOT_ICON_KEY);

    annot = HPDF_Page_CreateTextAnnot(page, rect3,
                "Annotation with Note Icon", NULL);
    HPDF_TextAnnot_SetIcon(annot, HPDF_ANNOT_ICON_NOTE);

    annot = HPDF_Page_CreateTextAnnot(page, rect4,
                "Annotation with Help Icon", NULL);
    HPDF_TextAnnot_SetIcon(annot, HPDF_ANNOT_ICON_HELP);

    annot = HPDF_Page_CreateTextAnnot(page, rect5,
                "Annotation with NewParagraph Icon", NULL);
    HPDF_TextAnnot_SetIcon(annot, HPDF_ANNOT_ICON_NEW_PARAGRAPH);

    annot = HPDF_Page_CreateTextAnnot(page, rect6,
                "Annotation with Paragraph Icon", NULL);
    HPDF_TextAnnot_SetIcon(annot, HPDF_ANNOT_ICON_PARAGRAPH);

    annot = HPDF_Page_CreateTextAnnot(page, rect7,
                "Annotation with Insert Icon", NULL);
    HPDF_TextAnnot_SetIcon(annot, HPDF_ANNOT_ICON_INSERT);

    encoding = HPDF_GetCurrentEncoder(pdf);

    annot = HPDF_Page_CreateTextAnnot(page, rect8,
                "Annotation with ISO8859 text ", encoding);

    HPDF_Page_SetFontAndSize(page, font, 12);

    HPDF_Page_BeginText(page);
    HPDF_Page_MoveTextPos(page, rect1[1] + 20, rect1[2] + 40);
    HPDF_Page_ShowText(page, "Comment Icon.");
    HPDF_Page_EndText(page);

    HPDF_Page_BeginText(page);
    HPDF_Page_MoveTextPos(page, rect2[1] + 20, rect2[2] + 40);
    HPDF_Page_ShowText(page, "Key Icon");
    HPDF_Page_EndText(page);

    HPDF_Page_BeginText(page);
    HPDF_Page_MoveTextPos(page, rect3[1] + 20, rect3[2] + 40);
    HPDF_Page_ShowText(page, "Note Icon.");
    HPDF_Page_EndText(page);

    HPDF_Page_BeginText(page);
    HPDF_Page_MoveTextPos(page, rect4[1] + 20, rect4[2] + 40);
    HPDF_Page_ShowText(page, "Help Icon");
    HPDF_Page_EndText(page);

    HPDF_Page_BeginText(page);
    HPDF_Page_MoveTextPos(page, rect5[1] + 20, rect5[2] + 40);
    HPDF_Page_ShowText(page, "NewParagraph Icon");
    HPDF_Page_EndText(page);

    HPDF_Page_BeginText(page);
    HPDF_Page_MoveTextPos(page, rect6[1] + 20, rect6[2] + 40);
    HPDF_Page_ShowText(page, "Paragraph Icon");
    HPDF_Page_EndText(page);

    HPDF_Page_BeginText(page);
    HPDF_Page_MoveTextPos(page, rect7[1] + 20, rect7[2] + 40);
    HPDF_Page_ShowText(page, "Insert Icon");
    HPDF_Page_EndText(page);

    HPDF_Page_BeginText(page);
    HPDF_Page_MoveTextPos(page, rect8[1] + 20, rect8[2] + 40);
    HPDF_Page_ShowText(page, "Text Icon(ISO8859-2 text)");
    HPDF_Page_EndText(page);
#
    HPDF_Page_BeginText(page);
    HPDF_Page_SetFontAndSize(page, font, 9);
    HPDF_Page_MoveTextPos(page, rect9[1] +10 , rect9[2] -10);
    uri = "http://winpg.jp/";
    HPDF_Page_ShowText(page, "URI (");
    HPDF_Page_ShowText(page, uri);
    HPDF_Page_ShowText(page, ")");
    annot = HPDF_Page_CreateURILinkAnnot(page, rect9, uri);
    HPDF_LinkAnnot_SetBorderStyle(annot, 1, 3, 2);
    HPDF_Page_EndText(page);


    # save the document to a file 
    HPDF_SaveToFile(pdf, fname);

    # clean up 
    HPDF_Free(pdf);

}

